﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace CSharp_To_HTML
{
    class TextBox2 : TextBox
    {
        private Timer _timer = new Timer();
        public event EventHandler TextChangedDelayed;

        public TextBox2()
        {
            _timer.Interval = 2000;
            _timer.Tick +=new EventHandler(_timer_Tick);
        }

        protected virtual void OnTextChangedDelayed()
        {
            if (TextChangedDelayed != null)
            {
                TextChangedDelayed(this, EventArgs.Empty);
            }
        }

        protected override void OnTextChanged(EventArgs e)
        {
            base.OnTextChanged(e);
            _timer.Stop();
            _timer.Start();
        }

        private void _timer_Tick(object sender, EventArgs e)
        {
                _timer.Stop();
                OnTextChangedDelayed();
        }

        public int DelayedEventInterval
        {
            get { return _timer.Interval; }
            set { _timer.Interval = value; }
        }
    }
}
